#include <bits/stdc++.h>

#define int long long
#define double long double
using namespace std;

struct segtree {
    vector<int> t, p;
    int sz;

    void init(vector<int> &a) {
        sz = 1;
        while (a.size() > sz) {
            sz *= 2;
        }
        t.resize(2 * sz, -1);
        p.resize(2 * sz, -2);
    }

    void push(int i) {
        if (2 * i + 1 >= t.size() || p[i] == -2) {
            return;
        }
        t[2 * i] = t[2 * i + 1] = p[2 * i] = p[2 * i + 1] = p[i];
        p[i] = -2;
    }

    void upd(int i, int l, int r, int ql, int qr, int val) {
        if (r <= ql || l >= qr) {
            return;
        }
        if (ql <= l && r <= qr) {
            t[i] = val;
            p[i] = val;
            return;
        }
        push(i);
        int m = (l + r) / 2;
        upd(2 * i, l, m, ql, qr, val);
        upd(2 * i, m, r, ql, qr, val);
        t[i] = min(t[2 * i], t[2 * i + 1]);
    }

    int get(int i, int l, int r, int qi) {
        if (r <= i || l >= i + 1) {
            return 2;
        }
        if (r - l == 1) {
            return t[i];
        }
        push(i);
        int m = (l + r) / 2;
        return min(get(2 * i, l, m, qi),
                   get(2 * i, m, r, qi));
    }
};

vector<int> l, r, val;
vector<int> order;
segtree st;


void dfs(int v) {
    if (val[v] == -1) {
        order.push_back(v);
    }
    if (l[v] != 0) {
        dfs(l[v]);
    }
    if (val[v] == 0) {
        order.push_back(v);
    }
    if (r[v] != 0) {
        dfs(r[v]);
    }
    if (val[v] == 1) {
        order.push_back(v);
    }
}

void dfs2(int v) {
    val[v] = st.get(1, 0, st.sz, v);
    if (val[v] == -1) {
        order.push_back(v);
    }
    if (l[v] != 0) {
        dfs2(l[v]);
    }
    if (val[v] == 0) {
        order.push_back(v);
    }
    if (r[v] != 0) {
        dfs2(r[v]);
    }
    if (val[v] == 1) {
        order.push_back(v);
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n >> q;
    l.resize(n + 1);
    r.resize(n + 1);
    val.resize(n + 1, -1);
    set<int> s;
    for (int i = 1; i <= n; ++i) {
        s.insert(i);
    }
    for (int i = 1; i <= n; ++i) {
        cin >> l[i] >> r[i];
        s.erase(l[i]);
        s.erase(r[i]);
    }
    if (n * q <= 25000000) {
        for (int i = 0; i < q; ++i) {
            int t;
            cin >> t;
            if (t == 1) {
                int l1, r1, x;
                cin >> l1 >> r1 >> x;
                for (int j = l1; j <= r1; ++j) {
                    val[j] = x;
                }
            } else {
                int x;
                cin >> x;
                order.clear();
                dfs(*s.begin());
                for (int j = 0; j < order.size(); ++j) {
                    if (order[j] == x) {
                        cout << j + 1 << "\n";
                        break;
                    }
                }
            }
        }
    } else {
        vector<int> ans(n + 100);
        st.init(val);
        for (int i = 0; i < q; ++i) {
            int t;
            cin >> t;
            if (t == 1) {
                int l1, r1, x;
                cin >> l1 >> r1 >> x;
                st.upd(1, 0, st.sz, l1, r1 + 1, x);
            } else {
                int x;
                cin >> x;
                if (order.empty()) {
                    dfs2(*s.begin());
                    for (int j = 0; j < order.size(); ++j) {
                        ans[order[j]] = j + 1;
                    }
                }
                cout << ans[x] << "\n";
            }
        }
    }
    return 0;
}